#include <iostream>

// Include-File fuer die Benutzung der Programmbibliothek CLN:
#include <cln.h>

/* 
   minimale Anzahl von Include-Files fuer dieses Programm
   ("cln.h" laedt alle Include-Files von CLN nach)

#include <cl_integer.h>
#include <cl_real.h>
#include <cl_integer_io.h>
#include <cl_rational_io.h>
*/

using namespace std;

int main(void)
{
  cl_I int_wert(1234);
  cl_RA rat_wert("2/13");

  cout << "### Konstruktortest" << endl;
  cout << " CLN-Integer-Wert (sollte 1234 sein) = " 
       << int_wert << endl;
  cout << "CLN-Rational-Wert (sollte 2/13 sein) = " 
       << rat_wert << endl << endl;

  cout << "### Eingabe- und Additionstest von CLN-Integer-Werten" << endl;
  cl_I i1, i2, i_res;
  cout << "1. CLN-Integer-Wert eingeben (kann viele Ziffern haben): ";
  cin >> i1;

  // Test mit cl_stdin statt mit cin
  cout << "2. CLN-Integer-Wert eingeben (kann viele Ziffern haben): ";
  cl_stdin >> i2;

  i_res = i1 + i2;
  cout << "Summe der beiden Werte = " << i_res << endl << endl;

  cout << "### Eingabe- und Additionstest von CLN-Rational-Werten" << endl;
  cl_RA rat1, rat2, rat_res;
  cout << "1. CLN-Rational-Wert (in der Form \"a\" oder \"a/b\"): ";
  cin >> rat1;

  // Test mit cl_stdin statt mit cin
  cout << "2. CLN-Rational-Wert (in der Form \"a\" oder \"a/b\"): ";
  cl_stdin >> rat2;

  rat_res = rat1 + rat2;
  cout << "Summe der beiden Werte = " << rat_res << endl;

  return 0;
}
